import * as React from 'react';
import { PureComponent } from 'react';
import * as _ from "lodash";
class Switch extends PureComponent {
    constructor() {
        super(...arguments);
        this.getSelectedIndexes = () => {
            if (!_.isArray(this.props.selected)) {
                return [this.props.selected];
            }
            return this.props.selected;
        };
        this.getViews = () => {
            //Get views from props
            let views = this.props.views || this.props.children || [];
            if (!_.isArray(views))
                views = [views];
            return views;
        };
    }
    render() {
        let views = this.getViews();
        let renderedViews = views.map((view, index) => {
            const selected = _.some(this.getSelectedIndexes(), (selectedIndex) => index === selectedIndex);
            const display = selected ? 'contents' : 'none';
            const View = view;
            const specificProps = this.props.props;
            return React.createElement("div", { key: index, style: { display } }, view);
        });
        if (renderedViews === [])
            return null;
        return React.createElement(React.Fragment, null, renderedViews);
    }
}
Switch.defaultProps = {
    selected: null
};
export default Switch;
//# sourceMappingURL=Switch.js.map