"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
exports.NsContext = React.createContext([]);
const { Provider: NamespaceProvider, Consumer: NamespaceConsumer } = exports.NsContext;
exports.Namespace = (props) => {
    // Read
    if (props.name == null) {
        const cprops = props;
        return React.createElement(NamespaceConsumer, null, (namespace) => {
            // console.log('namespace', namespace);
            if (typeof cprops.children == "function")
                return cprops.children(namespace);
            return cprops.children;
        });
    }
    // Write
    return React.createElement(NamespaceConsumer, null, (currentNamespace) => {
        const rprops = props;
        let newName = rprops.name;
        const parts = newName.split('/');
        parts.forEach((part, i) => {
            if (part === '' && i === 0) {
                currentNamespace = [];
                return;
            }
            if (part === '..') {
                currentNamespace.pop();
                return;
            }
            currentNamespace = currentNamespace.concat(part);
        });
        return React.createElement(NamespaceProvider, { value: currentNamespace }, props.children);
    });
};
exports.withNamespace = (WrappedComponent) => {
    return (props) => React.createElement(exports.Namespace, null, (namespace) => {
        return React.createElement(WrappedComponent, Object.assign({}, props, { namespace: namespace }));
    });
};
exports.withNamespaceClass = (WrappedComponent) => {
    return class WithName extends React.Component {
        render() {
            return React.createElement(exports.Namespace, null, (namespace) => {
                return React.createElement(WrappedComponent, Object.assign({}, this.props, { namespace: namespace }));
            });
        }
    };
};
exports.PrintNamespace = (props) => {
    return React.createElement(exports.Namespace, null, (namespace) => {
        return React.createElement("ol", null, namespace.join('.'));
    });
};
//# sourceMappingURL=namespaces.js.map